Index: trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc	(revision 8790)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc	(revision 8795)
@@ -40,21 +40,27 @@
 #include <TFile.h>
 
+// Core
 #include "MLog.h"
 #include "MLogManip.h"
 
 #include "MDirIter.h"
-#include "MRunIter.h"
+#include "MTaskList.h"
 #include "MParList.h"
-#include "MTaskList.h"
 #include "MEvtLoop.h"
 
 #include "MStatusDisplay.h"
 
+// General containers
 #include "MGeomCam.h"
+#include "MBadPixelsCam.h"
+#include "MCalibConstCam.h"
+#include "MPedestalCam.h"
+#include "MArrivalTimeCam.h"
+
+// General histograms
 #include "MHCamEvent.h"
-#include "MPedestalCam.h"
-#include "MBadPixelsCam.h"
-#include "MArrivalTimeCam.h"
-
+#include "MHVsTime.h"
+
+// Calibration containers
 #include "MCalibrationQECam.h"
 #include "MCalibrationBlindCam.h"
@@ -62,50 +68,46 @@
 #include "MCalibrationRelTimeCam.h"
 #include "MCalibrationChargePINDiode.h"
-#include "MCalibrationPatternDecode.h"
-
-#include "MCalibrationChargeCalc.h"
-#include "MCalibrationRelTimeCalc.h"
-
-#include "MCalibConstCam.h"
-
+
+// Calibration histograms
 #include "MHCalibrationChargeCam.h"
 #include "MHCalibrationChargeBlindCam.h"
 #include "MHCalibrationChargePINDiode.h"
 #include "MHCalibrationRelTimeCam.h"
-#include "MHCalibrationPulseTimeCam.h"
-#include "MHVsTime.h"
-#include "MHCamera.h"
-
-#include "MCalibCalcFromPast.h"
-
+
+// Tasks
 #include "MReadMarsFile.h"
 #include "MRawFileRead.h"
+#include "MTaskEnv.h"
 #include "MContinue.h"
+#include "MFillH.h"
+#include "MGeomApply.h"
+#include "MExtractTimeAndCharge.h"
 #include "MTriggerPatternDecode.h"
-#include "MFTriggerPattern.h"
-#include "MFDataPhrase.h"
-#include "MFilterList.h"
-#include "MGeomApply.h"
+#include "MCalibrationPatternDecode.h"
+#include "MCalibrationChargeCalc.h"
+#include "MCalibrationRelTimeCalc.h"
+#include "MCalibCalcFromPast.h"
 #include "MPedestalSubtract.h"
-#include "MPointingPosCalc.h"
 #include "MPedCalcFromLoGain.h"
-#include "MPedestalSubtract.h"
-#include "MExtractor.h"
-#include "MExtractTimeAndCharge.h"
+#include "MCalibrateData.h"
 #include "MExtractPINDiode.h"
 #include "MExtractBlindPixel.h"
-#include "MFCosmics.h"
-#include "MTaskEnv.h"
-#include "MCalibrateData.h"
 #include "MCalibrateRelTimes.h"
 #include "MBadPixelsCalc.h"
 #include "MBadPixelsTreat.h"
-#include "MFillH.h"
 #include "MWriteRootFile.h"
 
+// Filter
+#include "MFTriggerPattern.h"
+#include "MFCosmics.h"
+#include "MFilterList.h"
+#include "MFDataPhrase.h"
+
+// Classes for writing movies
 #include "MFEvtNumber.h"
 #include "MMoviePrepare.h"
 #include "MMovieWrite.h"
 #include "MImgCleanStd.h"
+
 
 ClassImp(MJCalibrateSignal);
Index: trunk/MagicSoft/Mars/mjobs/MJPedestal.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJPedestal.cc	(revision 8790)
+++ trunk/MagicSoft/Mars/mjobs/MJPedestal.cc	(revision 8795)
@@ -41,15 +41,10 @@
 // root classes
 #include <TF1.h>
+#include <TLine.h>
+#include <TLatex.h>
+#include <TLegend.h>
+
 #include <TEnv.h>
 #include <TFile.h>
-#include <TLine.h>
-#include <TLatex.h>
-#include <TString.h>
-#include <TCanvas.h>
-#include <TSystem.h>
-#include <TLegend.h>
-#include <TPad.h>
-#include <TEnv.h>
-#include <TH2F.h>
 
 // mars core
@@ -74,6 +69,6 @@
 #include "MPedestalPix.h"
 
+//#include "MHPedestalPix.h"
 #include "MCalibrationPix.h"
-#include "MHPedestalPix.h"
 #include "MHCalibrationPulseTimeCam.h"
 #include "MCalibrationPulseTimeCam.h"
@@ -92,9 +87,4 @@
 #include "MFTriggerPattern.h"
 #include "MBadPixelsCalc.h"
-
-#include "MPedPhotCam.h"
-#include "MPedPhotPix.h"
-#include "MPedestalCam.h"
-#include "MPedestalPix.h"
 #include "MPedestalSubtract.h"
 
@@ -121,5 +111,5 @@
     : fExtractor(NULL), fDisplayType(kDisplayDataCheck),
     fExtractType(kUsePedRun), fExtractionType(kFundamental),
-    fIsUseHists(kFALSE), fDeadPixelCheck(kFALSE), fMinEvents(50)
+    /*fIsUseHists(kFALSE),*/ fDeadPixelCheck(kFALSE), fMinEvents(50)
 {
     fName  = name  ? name  : "MJPedestal";
@@ -337,5 +327,5 @@
       }
     
-#if 0
+/*
     if (fIsUseHists)
       {
@@ -353,11 +343,9 @@
         disp5.CamDraw(c4, 2, 2, 5);
 
-        /*
-        TCanvas &c5 = fDisplay->AddTab("Difference Hist.");
-        c5.Divide(2,3);
-        
-        disp6.CamDraw(c5, 1, 2, 1);
-        disp7.CamDraw(c5, 2, 2, 5);
-        */
+        //TCanvas &c5 = fDisplay->AddTab("Difference Hist.");
+        //c5.Divide(2,3);
+        //
+        //disp6.CamDraw(c5, 1, 2, 1);
+        //disp7.CamDraw(c5, 2, 2, 5);
 
         TCanvas &c6 = fDisplay->AddTab("Difference Calc.");
@@ -368,5 +356,5 @@
         return;
       }
-#endif
+*/
     if (fDisplayType == kDisplayDataCheck)
       {
@@ -785,9 +773,6 @@
     }
 
-
-    if (HasEnv("UseHists"))
-      if (GetEnv("UseHists",kFALSE))
-        fIsUseHists = kTRUE;
-    
+//    fIsUseHists = GetEnv("UseHists", fIsUseHists);
+
     SetNoStorage(GetEnv("DisableOutput", IsNoStorage()));
 
@@ -844,4 +829,5 @@
 Int_t MJPedestal::PulsePosCheck(const MParList &plist) const
 {
+    /*
     if (fIsPixelCheck)
     {
@@ -853,5 +839,5 @@
         }
     }
-
+    */
     if (!fIsPulsePosCheck)
         return kTRUE;
@@ -869,5 +855,5 @@
     MCalibrationPulseTimeCam *cam = NULL;
     if (!fSequence.IsMonteCarlo())
-    {
+    {  /*
         if (fIsPixelCheck)
         {
@@ -885,5 +871,5 @@
             gPad->SaveAs(Form("%s/PulsePosTest_Pixel%04d.root",fPathOut.Data(),fCheckedPixId));
         }
-
+        */
         cam = (MCalibrationPulseTimeCam*)plist.FindObject("MCalibrationPulseTimeCam");
         if (!cam)
@@ -1066,8 +1052,8 @@
     pedlogain.SetPedestalUpdate(kFALSE);
     
-    MHPedestalCam hpedcam;
-    hpedcam.SetPedestalsOut(&fPedestalCamOut);
-    if (fExtractionType != kFundamental)
-        hpedcam.SetRenorm(kTRUE);
+//    MHPedestalCam hpedcam;
+//    hpedcam.SetPedestalsOut(&fPedestalCamOut);
+//    if (fExtractionType != kFundamental)
+//        hpedcam.SetRenorm(kTRUE);
 
     // To have it in the parlist for MEnv!
@@ -1172,5 +1158,5 @@
         break;
     }
-    
+/*
     if (fIsUseHists && fExtractor)
       {
@@ -1188,5 +1174,5 @@
         plist.AddToList(&hpedcam);
     }
-
+ */
     pedcalc.SetPedestalsOut(&fPedestalCamOut);
     pedlogain.SetPedestalsOut(&fPedestalCamOut);
Index: trunk/MagicSoft/Mars/mjobs/MJPedestal.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJPedestal.h	(revision 8790)
+++ trunk/MagicSoft/Mars/mjobs/MJPedestal.h	(revision 8795)
@@ -71,5 +71,5 @@
     Int_t fExtractionType;                   // Flag if the extractor is used to calculate the pedestals
 
-    Bool_t fIsUseHists;                      // Switch on histogramming or not
+//    Bool_t fIsUseHists;                      // Switch on histogramming or not
     Bool_t fDeadPixelCheck;                  // Should the dead pixel check be done?
 
@@ -113,5 +113,5 @@
     void SetExtractor(MExtractor* ext);
     void SetUseData()                           { fExtractType = kUseData;   }
-    void SetUseHists( const Bool_t b=kTRUE)     { fIsUseHists = b;  }
+//    void SetUseHists( const Bool_t b=kTRUE)     { fIsUseHists = b;  }
     void SetDeadPixelCheck(const Bool_t b=kTRUE) { fDeadPixelCheck = b; }
     void SetUsePedRun()                         { fExtractType = kUsePedRun; }
Index: trunk/MagicSoft/Mars/mjobs/MSequence.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MSequence.cc	(revision 8790)
+++ trunk/MagicSoft/Mars/mjobs/MSequence.cc	(revision 8795)
@@ -406,4 +406,6 @@
     if (!str.CompareTo("No_Moon", TString::kIgnoreCase))
         return kNoMoon;
+    if (!str.CompareTo("NoMoon", TString::kIgnoreCase))
+        return kNoMoon;
     if (!str.CompareTo("Twilight", TString::kIgnoreCase))
         return kTwilight;