Index: trunk/MagicSoft/Cosy/base/File.cc
===================================================================
--- trunk/MagicSoft/Cosy/base/File.cc	(revision 8846)
+++ 	(revision )
@@ -1,92 +1,0 @@
-#include "File.h"
-
-#include <stdlib.h>
-
-File::File(const char *name, const char *flags)
-{
-    f = fopen(name, flags);
-    if (!f)
-        printf("WARNING: Cannot open '%s'\n", name);
-}
-
-File::~File()
-{
-    if (f)
-        fclose(f);
-}
-
-char File::Getc() const
-{
-    return fgetc(f);
-}
-
-int File::Eof() const
-{
-    return feof(f);
-}
-
-void File::Seek(long pos) const
-{
-    fseek(f, pos, SEEK_SET);
-}
-
-void File::Reset() const
-{
-    fseek(f, 0, SEEK_SET);
-}
-
-long File::Tell() const
-{
-    return ftell(f);
-}
-
-long File::Size() const
-{
-    long l = ftell(f);
-    fseek(f, 0, SEEK_END);
-    long s = ftell(f);
-    fseek(f, l, SEEK_SET);
-    return s;
-}
-
-char *File::Gets(char *c, int cnt) const
-{
-    for (int i=0; i<cnt; i++)
-        *c++=fgetc(f);
-    *c='\0';
-
-    return c;
-}
-
-void File::Newline() const
-{
-    int g;
-    do g=fgetc(f);
-    while (g!=0x0A && g!=EOF);
-}
-
-int File::Geti(int cnt) const
-{
-    char *c = new char[cnt+1];
-    Gets(c, cnt);
-    int result = atoi(c);
-    delete c;
-    return result;
-}
-
-float File::Getf(int cnt) const
-{
-    char *c = new char[cnt+1];
-    Gets(c, cnt);
-    float result = atof(c);
-    delete c;
-    return result;
-}
-
-void File::Skip(int cnt) const
-{
-    char *c = new char[cnt+1];
-    Gets(c, cnt);
-    delete c;
-}
-
Index: trunk/MagicSoft/Cosy/base/File.h
===================================================================
--- trunk/MagicSoft/Cosy/base/File.h	(revision 8846)
+++ 	(revision )
@@ -1,33 +1,0 @@
-#ifndef FILE_H
-#define FILE_H
-
-#include <stdio.h>
-
-class File
-{
-private:
-    FILE *f;
-
-public:
-    File(const char *name, const char *flags);
-    ~File();
-
-    void Reset() const;
-    int  Eof() const;
-
-    void Seek(long pos) const;
-    long Tell() const;
-    long Size() const;
-
-    char  Getc() const;
-    char *Gets(char *c, int cnt) const;
-    int   Geti(int cnt) const;
-    float Getf(int cnt) const;
-
-    void Newline() const;
-    void Skip(int cnt) const;
-
-    int operator!() { return !f; }
-};
-
-#endif
Index: trunk/MagicSoft/Cosy/base/timer.cc
===================================================================
--- trunk/MagicSoft/Cosy/base/timer.cc	(revision 8846)
+++ 	(revision )
@@ -1,153 +1,0 @@
-#include "timer.h"
-
-#include <stdio.h>
-#include <iostream.h>
-
-#include <math.h>           // modf
-#include "sys/time.h"       // struct timeval
-#include "slalib/slalib.h"  // slacldj
-
-void Timer::SetTimer(int tv_sec, double tv_usec)
-{
-    fSecs = tv_sec;
-    fMs = tv_usec;
-
-    SetMjd((fMs+fSecs)/(60*60*24) + 40587);
-
-    fSec  = tv_sec%60;
-    tv_sec /= 60;
-
-    fMin = tv_sec%60;
-    tv_sec /= 60;
-
-    fHor = tv_sec%24;
-    tv_sec /= 24;
-
-//    fDiv = fmod((fMs+fSecs)/(60*60*24), 1.0);
-}
-
-void Timer::GetTimeval(struct timeval *tv) const
-{
-    tv->tv_sec  = fSecs;
-    tv->tv_usec = (__suseconds_t)fMs;
-}
-
-/*
-void Timer::Set(const long mjd)
-{
-    SetMjd(mjd);
-
-    //
-    // Express day in Gregorian calendar
-    //  (taken from slalib slaDjcl)
-    //
-    const long jd   = mjd + 2400001;
-    const long n4   = (((((jd*4-17918)/146097)*6)/4+1)/2+jd-37)*4;
-    const long nd10 = (((n4-237)%1461)/4)*10+5;
-
-    fYea = n4/1461 - 4712;
-    fMon = ((nd10/306+2)%12) + 1;
-    fDay = (nd10%306)/10 + 1;
-}
-*/
-void Timer::SetTimer(const struct timeval *tv)
-{
-    SetTimer(tv->tv_sec, (double)tv->tv_usec/1000000.0);
-}
-
-Timer::Timer(double t)
-{
-    double inte;
-    double frac = modf(t, &inte);
-    SetTimer(inte, frac);
-}
-
-Timer::Timer(struct timeval *tv)
-{
-    SetTimer(tv);
-}
-
-Timer::Timer(const Timer &t)
-{
-    fMs   = t.fMs;
-    fDiv  = t.fDiv;
-    fSec  = t.fSec;
-    fSecs = t.fSecs;
-    fMin  = t.fMin;
-    fHor  = t.fHor;
-    fDay  = t.fDay;
-    fMon  = t.fMon;
-    fYea  = t.fYea;
-    fMjd  = t.fMjd;
-}
-
-void Timer::SetMjd(double mjd)
-{
-    //
-    // Express day in Gregorian calendar
-    //  (taken from slalib slaDjcl)
-    //
-    fMjd = mjd;
-
-    const long jd   = (long)mjd + 2400001;
-    const long n4   = (((((jd*4-17918)/146097)*6)/4+1)/2+jd-37)*4;
-    const long nd10 = (((n4-237)%1461)/4)*10+5;
-
-    fYea = n4/1461 - 4712;
-    fMon = ((nd10/306+2)%12) + 1;
-    fDay = (nd10%306)/10 + 1;
-
-    fDiv = fmod(mjd, 1.0);
-
-    mjd -= 40587;
-
-    mjd *= 24;
-    fHor = (int)fmod(mjd, 24);
-
-    mjd *= 60;
-    fMin = (int)fmod(mjd, 60);
-
-    mjd *= 60;
-    fSec = (int)fmod(mjd, 60);
-
-    fMs = fmod(mjd * 1000, 1000)/1000;
-}
-
-double Timer::Now() //[s]
-{
-    struct timeval tv;
-    gettimeofday(&tv, NULL);
-
-    SetTimer(&tv);
-
-    return fMs+fSecs;
-}
-
-Timer::operator double() const //[s]
-{
-    return fMs+fSecs;
-}
-
-void Timer::Print()
-{
-    cout << fSec << "s +" << fMs << "s" << endl;
-}
-
-const char *Timer::GetTimeStr()
-{
-    sprintf(fDateStr, "%2d/%02d/%02d %d:%02d:%02d.%06li",
-            fYea, fMon, fDay, fHor, fMin, fSec, (long)(1000000.0*fMs));
-
-    return fDateStr;
-}
-
-ostream &operator<<(ostream &out, Timer &t)
-{
-    char text[256];
-
-    sprintf(text, "%2d/%02d/%02d %d:%02d:%02d.%01li",
-            t.fYea, t.fMon, t.fDay, t.fHor, t.fMin, t.fSec, (long)(10.0*t.fMs));
-
-    out << text;
-    return out;
-}
Index: trunk/MagicSoft/Cosy/base/timer.h
===================================================================
--- trunk/MagicSoft/Cosy/base/timer.h	(revision 8846)
+++ 	(revision )
@@ -1,78 +1,0 @@
-#ifndef COSY_Timer
-#define COSY_Timer
-
-struct timeval;
-
-class ostream;
-
-class Timer
-{
-    friend ostream &operator<<(ostream &out, Timer &t);
-private:
-    double fMs;  // Microsec in units of sec as returned by gettimeofday
-    int fSecs;   // Seconds as returned by gettimeofday
-
-    int fSec;    // Sec of time
-    int fMin;    // Min of time
-    int fHor;    // Hor of time
-    int fDay;    // Day of time
-    int fMon;    // Mon of time
-    int fYea;    // Yea of time
-
-    double fDiv; // Division of day
-    double fMjd; // MJD
-
-    char fDateStr[30];
-
-    //void Set(const long mjd);
-
-public:
-    Timer(int d, int m, int y, int h, int min, int s, double ms)
-        : fMs(ms), fSecs(0), fSec(s), fMin(m), fHor(h), fDay(d), fMon(m), fYea(y), fDiv(0), fMjd(0) {}
-    Timer() : fMs(0), fSecs(0), fSec(0), fMin(0), fHor(0), fDay(0), fMon(0), fYea(0), fDiv(0), fMjd(0) {}
-    Timer(double t);
-    Timer(struct timeval *tv);
-    Timer(const Timer &t);
-
-    void SetTimer(int tv_sec, double tv_usec);
-    void SetTimer(const struct timeval *tv);
-    void SetTimer(int y, int m, int d, int h, int min, int s, double ms)
-    {
-        fMs = ms;
-        fSec = s;
-        fMin = min;
-        fHor = h;
-        fDay = d;
-        fMon = m;
-        fYea = y;
-    }
-
-    void GetTimeval(struct timeval *tv) const;
-
-    int GetSecs() { return fSecs; }
-
-    double Now(); //[s]
-    double GetMjd() const { return fMjd/*+fDiv*/; }
-
-    virtual void SetMjd(double mjd);
-
-    int Day() const   { return fDay; }
-    int Month() const { return fMon; }
-    int Year() const  { return fYea; }
-
-    int H() const { return fHor; }
-    int M() const { return fMin; }
-    int S() const { return fSec; }
-    int MilliSec() const { return (int)(fMs*1000); }
-    double MicroSec() const { return fMs; }
-
-    const char *GetTimeStr();
-
-    void Print();
-
-    operator double() const; //[s]
-};
-
-ostream &operator<<(ostream &out, Timer &t);
-
-#endif